﻿/*
	WalkerGrid.as
	Pixel Walker Grid Class - grid for walkers, store model data and render bitmap
	(c) Keeran Raj Hawoldar
	http://www.keeran.com
*/
import flash.display.*;
import flash.geom.Point;

class WalkerGrid extends MovieClip
{
	private var bitmapData:BitmapData;
	private var bitmapMc:MovieClip;
	
	public var grid_width:Number;
	public var grid_height:Number;
	public var walkers = new Array();
	public var origin:Point;
	public var count:Number;
	
	
	public function WalkerGrid(grid_width:Number, grid_height:Number, count:Number)
	{
		this.grid_width = grid_width;
		this.grid_height = grid_height;	
		this.count = count;
		this.origin = new Point(grid_width/2,grid_height/2);
		
	}
	
	public function init()
	{
		// start all walkers from the same place (for now!)
		for (var i:Number = 0; i < this.count; i++)
		{
			this.walkers.push(new Walker(this.origin.x, this.origin.y, i));
		}	
		trace("Grid init() - Walkers created: " + this.walkers.length);
		// create a bitmap object to render

		this.bitmapData = new BitmapData(this.grid_width, this.grid_height, false, 0xCCCCCC);

	}
	
	public function render()
	{
		for (var i:Number = 0; i < this.count; i++)
		{
			var w:Walker = this.walkers[i];
			w.proc();
			this.bitmapData.setPixel(w.x, w.y, w.colour);
		}
	}
	
	public function getBitmapData():BitmapData
	{
		return this.bitmapData;
	}
	
	public function setOrigin(o:Point)
	{
		trace(o);
		this.origin = o;
		trace("New origin set: " + this.origin.x + "," + this.origin.y);
	}
}